/* Micro Java: base class for stack handling (mah 99-5-10)
   =========================================
*/
package MJ.VM;


public class Stack {
  private int data[]; // data area. automatically resized
  private int offset; // current size of stack

  Stack (int entries) { // new stack with the given initial size
    data = new int[entries];
  }

  int SP () { // returns the stack pointer
    return offset;
  }

  void set (int idx, int val) { // sets the specified value at idx
    if (idx >= offset) throw new ArrayIndexOutOfBoundsException(idx);
    data[idx] =val;
  }

  void setChar (int idx, byte ch) { // same for character values
    set(idx, (int)ch);
  }

  int get (int idx) { // fetches a value at given index
    if (idx >= offset) throw new ArrayIndexOutOfBoundsException(idx);
    return data[idx];
  }

  byte getChar (int idx) { // same for character values
    int val = get(idx);
    return (byte)val;
  }

  void push (int val) { // push a value onto the stack (grows if necessary)
    int d[];
    if (offset == data.length) { // grow array
      d = new int[offset+100];
      System.arraycopy(data, 0, d, 0, offset);
      data = d;
    }
    data[offset++] = val;
  }

  int pop () {    // pops value from stack
    return data[--offset];
  }

  void cut (int off) { // cuts everything on top of off from the stack
    offset = off;
  }

}